unit DataSourceRTTIU;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, DBCtrls, Grids, DBGrids, Db, DBTables;

type
  TForm1 = class(TForm)
    Table1: TTable;
    Query1: TQuery;
    DataSource1: TDataSource;
    DataSource2: TDataSource;
    DBGrid1: TDBGrid;
    DBNavigator1: TDBNavigator;
    Button1: TButton;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

uses
  TypInfo;

procedure SetDataSource(DataSource: TDataSource;
  const ControlsToChange: array of const);
var
  I: integer;
  PropInfo: PPropInfo;
begin
  for I := Low(ControlsToChange) to High(ControlsToChange) do
    with TVarRec(ControlsToChange[I]) do
      { Sanity check to see if it is an object }
      if VType = vtObject then
      begin
        PropInfo := GetPropInfo(VObject.ClassInfo, 'DataSource');
        if Assigned(PropInfo) then
          SetOrdProp(VObject, PropInfo, LongInt(DataSource));
      end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  SetDataSource(DataSource1, [DBGrid1, DBNavigator1]);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  SetDataSource(DataSource2, [DBGrid1, DBNavigator1]);
end;

end.
