unit GenericPropertyRTTIU;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, DBCtrls, Grids, DBGrids, Db, DBTables;

type
  TForm1 = class(TForm)
    Table1: TTable;
    Query1: TQuery;
    DataSource1: TDataSource;
    DataSource2: TDataSource;
    DBGrid1: TDBGrid;
    DBNavigator1: TDBNavigator;
    Button1: TButton;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

uses
  TypInfo;

//SetTo must be an array where the first element is the target new value
procedure ChangeProperty(const Prop: String;
  const SetTo, Components: array of const);
var
  I: integer;
  PropInfo: PPropInfo;
  Obj: TObject;
begin
  for I := Low(Components) to High(Components) do
    if TVarRec(Components[I]).VType = vtObject then
    begin
      Obj := TVarRec(Components[I]).VObject;
      PropInfo := GetPropInfo(Obj.ClassInfo, Prop);
      if Assigned(PropInfo) then
        with TVarRec(SetTo[Low(SetTo)]) do
          case VType of
            vtInteger, vtBoolean, vtChar, vtObject:
              SetOrdProp(Obj, PropInfo, VInteger);
            vtExtended:
              SetFloatProp(Obj, PropInfo, VExtended^);
            vtString:
              SetStrProp(Obj, PropInfo, VString^);
          end;
    end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  ChangeProperty('DataSource', [DataSource1], [DBGrid1, DBNavigator1])
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  ChangeProperty('DataSource', [DataSource2], [DBGrid1, DBNavigator1])
end;

end.
